#
#
# $Id: httpext.rb,v 1.8 2003/12/07 00:47:26 Yuukis Exp $
#
#
$KCODE = 'e'

class AboneExcepton < StandardError ; end  # for get
class CookieExcepton < StandardError ; end # for post
class TimeExcepton < StandardError ; end   # for post

module Net2ch
	require 'open3'
	require 'nkf'
	require 'net/http'
	Net::HTTP.version_1_2

	#
	# Load gzip
	#

	gzip = ''
	ENV['PATH'].split(':').each {|path|
		if File.executable?("#{path}/gzip")
			gzip = "#{path}/gzip"
			break
		end
	}
	
	if gzip == ''
		puts "Can't find the gzip in \$PATH !!"
		GZIP = false
	else
		GZIP = gzip.concat(' -d')
	end

	POST_LAST = '.last'

	@@proxy = [nil, nil]
	@@agent = $0

	module CacheInfo
		def CacheInfo.read(file)
			return(false) unless File.exist?(file)
			last = IO.readlines(file).join
			last.sub!(/Last-Modified: /, '').chomp!
			return(last)
		end
	
		def CacheInfo.write(str, file)
			fh = open(file, 'w')
			fh.write "Last-Modified: #{str}\n"
			fh.close
		end
	end

	def Net2ch.set_proxy(get_host, get_port, post_host, post_port)
		@@proxy = [get_host, get_port, post_host, post_port]
	end

	def Net2ch.set_agent(ua)
		@@agent = ua
	end
	
	def Net2ch.get(url, last = false, bytes = false)
		header = {}
		header['User-Agent']= @@agent
		header['If-Modified-Since']= CacheInfo.read(last) if File.exist?(last)
		header['Accept-Encoding']= 'gzip' if GZIP
		header['Range']= bytes if bytes

		server = '' ; path = ''
		url.sub(/http:\/\/(.*?)(\/.*)/) { server = $1 ; path = $2 }

		Net::HTTP.start(server, 80, @@proxy[0], @@proxy[1]) {|http|
			begin

			response , = http.get(path, header)
			case response.code
			when '304'  # Use Local Copy
				return([true, response])
			when '206'  # Partical Content
				if response.body[0] == 10
					return([true, response])
				else  # "ABone" ?
					raise AboneExcepton
				end
			when '200'  # OK
				return([true, response])
			when '416'  # Requested Range Not Satisfiable
				raise AboneExcepton
			else
				return([false, response])
			end
			rescue AboneExcepton
				header.delete('Range')
				header.delete('If-Modified-Since')
				retry
			end
		}
	end

	def Net2ch.get_keep(url, local)
		result, response = get(url, local + POST_LAST)
		case response.code
		when '304'  # Use Local Copy
			return([true, response])
		when '200'  # OK
			if GZIP
				fh = open("#{local}.gz", 'w')
			else
				fh = open(local, 'w')
			end
			fh.write response.body
			fh.close
			if GZIP
				i, o, e = Open3.popen3("#{GZIP} #{local}.gz")
				i.close
				File.rename("#{local}.gz", local) if e.readlines != []
			end
			CacheInfo.write(response.header['Last-Modified'], local + POST_LAST)
			return([true, response])
		else
			return([false, response])
		end
	end

	def Net2ch.post(url, name, mailto, message)
		kakikomu = '񤭤'
		kakikomu = encode(kakikomu)
		name = encode(name)
		mailto = encode(mailto)
		message = encode(message)

		num_of_trial = 0 
		time = (Time.now - 100).to_i.to_s

		header = {}
		header['User-Agent']= @@agent
		header['X-2ch-UA']= @@agent
		header['Referer']= url
		header['Content-Type']= 'application/x-www-form-urlencoded'
		header['Cookie']= "NAME=#{name};MAIL=#{mailto}"

		# url = 'http://pc.2ch.net/test/read.cgi/unix/1068867786/'
		server = '' ; board = '' ; thread = ''
		url.sub(/http:\/\/(.*?)\/test\/read.cgi\/(.*)\/(.*)\//) {
			server = $1 ; board = $2 ; thread = $3
		}

		# ̣Ϥʤ
		pre_sub = "submit=#{kakikomu}&FROM=#{name}&mail=#{mailto}&MESSAGE=#{message}"
		post_sub = "&bbs=#{board}&key=#{thread}&time=#{time}"

		Net::HTTP.start(server, 80, @@proxy[2], @@proxy[3]){ |http|
			begin
				response , = http.post('/test/bbs.cgi', pre_sub + post_sub, header)

				body = NKF::nkf('-exS',response.body)
				if response.code == '200'
				# from navi2ch. Thanx !
					if /񤭤ߤޤ/ =~ body
						return true, true
					elsif /ţңңϣ - (\d+) / =~ body
						return false, " Samba24 ERROR #{$1} - Ϣꤷ᤮ ?"
					elsif /ţңңϣҡ([^<]+)/ =~ body
						return false, $1
					elsif /ţңңϣҡ/ =~ body
						/<b>(.*?)<br>/ =~ body
						return false, $1
					elsif /ţңңϣ - / =~ body
						/ţңңϣ - (.*?)<br>/ =~ body
						return false, $1
					elsif /åʤڤǤ/ =~ body || /\<!-- 2ch_X:cookie --\>/ =~ body
						num_of_trial += 1 
						if num_of_trial < 2
							header['Cookie'] += ';' + response['Set-Cookie']
							raise CookieExcepton
						end
						return false, 'cookie'
					else
						STDERR.puts 'Post Error: TYPE UNKNOWN (1).'
						STDERR.print body
						return false, 'type_1_log'
					end
				else
					STDERR.puts 'Post Error: TYPE UNKNOWN (2).'
					STDERR.print body
					return false, 'type_2_log'
				end
			rescue TimeExcepton
				retry
			rescue CookieExcepton
				retry
			rescue
				STDERR.puts 'Post Error: TYPE UNKNOWN (3).'
				return false, 'type_3'
			end
		}
	end

	def Net2ch.encode(str)
		str = NKF::nkf('-sxE', str)
		str.gsub(/[^a-zA-Z0-9_.-]/n){sprintf('%%%02X',$&.unpack('C')[0]) }
	end
end
