#
#
# $Id: migemoext.rb,v 1.7 2003/12/09 15:21:39 Yuukis Exp $
#
#
$KCODE = 'e'

module MigemoExt
	require 'open3'

	@@migemo_cache = {}
	@@cmigemo = ''
	@@migemo_flag = false

	case CFG::EXT.migemo_flag
	when 'R'  # Ruby/Migemo
		begin
			require 'migemo'
			raise LoadError unless File.exist?(CFG::EXT.migemo_dict)
			raise LoadError unless File.exist?(CFG::EXT.migemo_dict_cache)
			MigemoDict = MigemoStaticDict.new(CFG::EXT.migemo_dict)
			MigemoDictCache = MigemoDictCache.new(CFG::EXT.migemo_dict_cache)
			@@migemo_flag = 'R'
		rescue LoadError
			@@migemo_flag = false
		end
	when 'C'  # C/Migemo
		begin
			ENV['PATH'].split(':').each {|path|
				if File.executable?("#{path}/cmigemo")
					@@cmigemo = "#{path}/cmigemo"
					break
				end
			}
			raise LoadError if @@cmigemo == ''
			raise LoadError unless File.exist?(CFG::EXT.migemo_dict)
			@@migemo_flag = 'C'
		rescue LoadError
			@@migemo_flag = false
		end
	else
		@@migemo_flag = false
	end

	if CFG::EXT.migemo_flag != @@migemo_flag
		puts CFG::NLS.migemo_load_error
		TYPE = false
		VERSION = false
	elsif @@migemo_flag == false
		TYPE = false
		VERSION = false
	elsif @@migemo_flag == 'R'
		TYPE = 'Ruby'
		VERSION = Migemo::VERSION
	elsif @@migemo_flag == 'C'
		TYPE = 'C'
		VERSION = false  # --version ץդʤʡ
	end


	def MigemoExt.regex(word)
		escape(word)
		if @@migemo_cache.include?(word)
			mregex = @@migemo_cache[word]
		else
			case @@migemo_flag
			when 'R'
				m = Migemo.new(MigemoDict, word)
				m.dict_cache = MigemoDictCache
				mregex = m.regex.chomp
			when 'C'
				i, o, e = Open3.popen3("#{@@cmigemo} -d #{CFG::EXT.migemo_dict} -w '#{word}'")
				i.close
				if e.readlines == []
					o = o.readlines.join
					o.gsub!(/^\(/, '')
					o.gsub!(/\)$/, '')
					mregex = o.chomp
				else
					return(false)
				end
			end
			@@migemo_cache[word]= mregex
		end

		return(Regexp.new(mregex))
	end

	def MigemoExt.escape(str)
		str.gsub!(/\//, '\/')
		str.gsub!(/\(/, '\(')
		str.gsub!(/\)/, '\)')
		str.gsub!(/\[/, '\[')
		str.gsub!(/\]/, '\]')
	end
end
